      PROGRAM MAP_STEEL_MUCG46
C Copyright Dr. H. K. D. H. Bhadeshia, University of Cambridge
C MUCG46.FOR
C Department of Materials Science and Metallurgy, Pembroke St. Cambridge CB2 3QZ
C Version 1.1, May 1990
C Version 1.2, Feb 1991, better Ms calculation
C Version 1.3, May 1991, graphics
c Version 1.4 Consistent with MUCG64
C Version 1.5 New Widmanstatten ferrite logic WSTION WSTINE
C Version 1.6 REED, REEDI, LOGO, BOUND included
C Version 1.7 July 1993 CG modified
C
C FTVSCLR PROGRAM=.THERMO:MUCG45 DATA=.DATA NAG
C
C 6 MARCH 1987
C
C TYPICAL DATASET FOLLOWS
C  3 0 (number of steels. zero if rate constants etc not needed)
C  0.39  2.05  0.00  4.08  0.00  0.00  0.00    1
C  0.22  2.03  3.00  0.00  0.00  0.00  0.00    4
C  0.44  1.74  0.67  1.85  0.39  0.83  0.09    3
C   C     SI    MN    NI    MO    CR    V    NUMBER
C
C MAP subroutines used :-     MAP Functions used :-
C
C STEEL :-                    STEEL :-
C
C   MAP_STEEL_AXTO               MAP_STEEL_AFEG
C   MAP_STEEL_GMAAX              MAP_STEEL_CG
C   MAP_STEEL_OMEGA              MAP_STEEL_DAFEG
C   MAP_STEEL_TTTT               MAP_STEEL_DCG
C   MAP_STEEL_WSTINE             MAP_STEEL_ENERGY
C                                MAP_STEEL_FTO1
C UTIL :-                        MAP_STEEL_WSFUN
C
C   MAP_UTIL_ANALY
C   MAP_UTIL_REEDI
C   MAP_UTIL_REED
C
C -------------------------------------------------------------------
C Start of Program
C
C
      IMPLICIT NONE
C
      DOUBLE PRECISION BDIF(40), BSH(40), BTEM(40), C(8)
      DOUBLE PRECISION DFPRO(40), DDFTO(100), DT4(100), DXQ(40)
C
      DOUBLE PRECISION A, A1, A44, AEQ, AFE, AFE44, AFEQ, AJ, AJ1
      DOUBLE PRECISION BS, CONST, CORR, CTEMP, DA44, DAFE44
      DOUBLE PRECISION DF441, DIFFT, ETEQ, ETEQ2, F, F44, FPRO
      DOUBLE PRECISION FPROA, FSON, FTO, GMAX, H, H1, MS, R, S, S1
      DOUBLE PRECISION SHEART, SLOPE, STRAIN, T, T0, T10, T20, TEQ, TEQ2
      DOUBLE PRECISION V14, W, W1, WS, WS1, X, XA, X1, X44
      DOUBLE PRECISION XBAR, XEQ, XEQ2, XMS, XTO, XTO400
C
      DOUBLE PRECISION MAP_STEEL_AFEG, MAP_STEEL_CG, MAP_STEEL_DAFEG
      DOUBLE PRECISION MAP_STEEL_DCG, MAP_STEEL_ENERGY, MAP_STEEL_FTO1
      DOUBLE PRECISION MAP_STEEL_WSFUN
C
      INTEGER I, IK, IMAX, J1, J2, J5, J6, J8, J98, J99, JN
C
      J1=20
C
C ******* Start of loop '30' *******
C
      DO 30 I=1,J1,1
C
C Initialise variables to zero
C
       IMAX = 0
       DO 2 IK=1,40
        BSH(IK)   = 0
        BDIF(IK)  = 0
        BTEM(IK)  = 0
        DXQ(IK)   = 0
        DT4(IK)   = 0
        DDFTO(IK) = 0
        DFPRO(IK) = 0
2      CONTINUE
C
       CALL LOGO
C
       WRITE(*,1085)
C
       CALL MAP_UTIL_REEDI(J6)
C
       WRITE(*,1050)
C
       CALL MAP_UTIL_REED(C(1))
C
       IF(C(1) .LT. 0.1D-03 .OR. C(1) .GT. 2.0D+00)
     & CALL BOUND(C(1),0.1D-03,2.0D+00)
       WRITE(*,1055)
C
       CALL MAP_UTIL_REED(C(2))
C
       IF(C(2) .LT. 0.0D+00 .OR. C(2) .GT. 2.5D+00)
     & CALL BOUND(C(2),0.0D+00,2.5D+00)
       WRITE(*,1060)
C
       CALL MAP_UTIL_REED(C(3))
C
       IF(C(3) .LT. 0.0D+00 .OR. C(3) .GT. 3.5D+00)
     & CALL BOUND(C(3),0.0D+00,3.5D+00)
       WRITE(*,1065)
C
       CALL MAP_UTIL_REED(C(4))
C
       IF(C(4) .LT. 0.0D+00 .OR. C(4) .GT. 4.5D+00)
     & CALL BOUND(C(4),0.0D+00,4.5D+00)
       WRITE(*,1070)
C
       CALL MAP_UTIL_REED(C(5))
C
       IF(C(5) .LT. 0.0D+00 .OR. C(5) .GT. 1.5D+00)
     & CALL BOUND(C(5),0.0D+00,1.5D+00)
       WRITE(*,1075)
C
       CALL MAP_UTIL_REED(C(6))
C
       IF(C(6) .LT. 0.0D+00 .OR. C(6) .GT. 3.5D+00)
     & CALL BOUND(C(6),0.0D+00,3.5D+00)
       WRITE(*,1080)
C
       CALL MAP_UTIL_REED(C(7))
C
       IF(C(7) .LT. 0.0D+00 .OR. C(7) .GT. 1.5D+00)
     & CALL BOUND(C(7),0.0D+00,1.5D+00)
       WRITE(*,1040)
       WRITE(*,1035)
       WRITE(*,1045) J6
       WRITE(*,1025) (C(J5),J5 = 1,7)
C
       CALL MAP_STEEL_OMEGA(C,W,XBAR,T10,T20,0)
C
       WRITE(*,1025) (C(J5),J5 = 1,7)
C
       FTO = -1.0
C
       WRITE (6,1035)
       X1 = C(1)
       WRITE (6,1020) X1,T10,T20,W
       WRITE(*,1040)
C
       XA = 0.001D+00 
       R  = 8.31432D+00
       W1 = 48570.0D+00
       H  = 38575.0D+00
       S  = 13.48D+00
       T0 = 273.15D+00
C
       WRITE(*,1030) 
       XEQ2   = 0.15D+00
       STRAIN = 50.00D+00
       XEQ    = 0.2D+00
       XTO    = 0.07D+00
       XTO400 = 0.06D+00
       X44    = 0.1D+00
       CONST  = 1.0D+00
       CORR   = 1.0D+00
       SLOPE  = 1.0D+00
	 JN = 1000
       J8 = 0
C 
C ******* Start of loop '27' *******
C 
       DO 27 J2=473,1173,20
        J8     = J8+1
        XTO    = XTO+0.0001D+00
        XTO400 = XTO400+0.0001D+00
        X44    = 0.3*XEQ
        T      = J2*1.0D+00
        CTEMP  = T-273.00D+00
C
        IF (T .LE. 1000.0) GOTO 4
C
        H1 = 105525.0D+00
        S1 = 45.34521D+00
        GOTO 6
C
4       H1 = 111918.0D+00
        S1 = 51.44D+00
6       F  = MAP_STEEL_ENERGY(T,T10,T20)
C
        AJ  = 1.0D+00-DEXP(-W/(R*T))
        AJ1 = 1.0D+00-DEXP(-W1/(R*T))
8       TEQ = R*T*MAP_STEEL_AFEG(XEQ,AJ)-F
C
        IF (DABS(TEQ) .LT. 1.0) GOTO 10
C 
        ETEQ = MAP_STEEL_DAFEG(XEQ,AJ)*R*T
        XEQ  = XEQ-TEQ/ETEQ
        GOTO 8
C
10      TEQ2 = R*T*MAP_STEEL_AFEG(XEQ2,AJ)-F-STRAIN
        IF (DABS(TEQ2) .LT. 1.0) GOTO 12
        ETEQ2 = MAP_STEEL_DAFEG(XEQ2,AJ)*R*T
        XEQ2  = XEQ2-TEQ2/ETEQ2
        GOTO 10
C
12      AEQ  = MAP_STEEL_CG(XEQ,T,W,R)
        AFEQ = MAP_STEEL_AFEG(XEQ,AJ)
        IF (XEQ .LT. X1+0.0004) GOTO 28
        A    = MAP_STEEL_CG(X1,T,W,R)
        AFE  = MAP_STEEL_AFEG(X1,AJ)
        FSON = R*T*(XA*(AEQ-A)+(1-XA)*(AFEQ-AFE))
        FPRO = R*T*(X1*(AEQ-A)+(1-X1)*(AFEQ-AFE))
C
C V14 is the free energy needed to nucleate Widmanstatten ferrite.
C If V14=0, jump to line 102.
C
        V14 = MAP_STEEL_WSFUN(T,T0)
        IF (V14 .GE. 0.0) THEN
          X44 = 99999999999.99999
          GOTO 18
        ENDIF
C
14      A44   = MAP_STEEL_CG(X44,T,W,R)
        AFE44 = MAP_STEEL_AFEG(X44,AJ)
        F44   = R*T*(X44*(AEQ-A44)+(1-X44)*(AFEQ-AFE44))
        F44   = F44-V14
        IF (DABS(F44) .GE. 10.0) GOTO 16
        GOTO 18
C
16      DA44   = MAP_STEEL_DCG(X44,T,W,R)
        DAFE44 = MAP_STEEL_DAFEG(X44,AJ)
        DF441  = R*T*(AEQ-X44*DA44-AFEQ+X44*DAFE44-DAFE44-A44+AFE44)
        X44    = X44-F44/DF441
        GOTO 14
C
18      FPROA = FPRO*((XEQ-XA)/(XEQ-X1))
        CALL MAP_STEEL_GMAAX(A1,A,W1,F,R,T,X,AFE,H1,S1)
        GMAX = R*T*(A1-A)
        IF (FTO .GE. 0.0) GOTO 20
        FTO = MAP_STEEL_FTO1(H,S,X1,T,W,W1,H1,S1,F,AJ,AJ1,R)
        GOTO 22
C
20      FTO = 0.0
22      CALL MAP_STEEL_AXTO(H,S,H1,S1,XTO,T,W,W1,F,AJ,AJ1,
     &  0.0D+00,JN,J98,R)
        CALL MAP_STEEL_AXTO(H,S,H1,S1,XTO400,T,W,W1,F,AJ,
     &  AJ1,400.0D+00,JN,J99,R)
        CALL MAP_STEEL_TTTT(T,GMAX,SHEART,DIFFT,R)
C
        IF (X44 .EQ. 0.0) GOTO 24 
        GOTO 26
C
24      SHEART = 1D+20
26      WRITE(*,1005) FPRO,FPROA,GMAX,CTEMP,X,FSON,XEQ,XEQ2,FTO,XTO,J98, 
     &  X44,XTO400,J99,SHEART,DIFFT
C 
C Plot 
        IMAX       = IMAX+1
        BSH(IMAX)  = SHEART
        BDIF(IMAX) = DIFFT
        BTEM(IMAX) = CTEMP
        WRITE(*,1090)IMAX,BSH(IMAX),BDIF(IMAX),BTEM(IMAX)
C 
C
        DXQ(J8)   = XEQ
        DDFTO(J8) = FTO
        DT4(J8)   = CTEMP
        DFPRO(J8) = FPRO
27     CONTINUE
C
C ******* End of loop '27' *******
C
28     J8 = J8-1
       WRITE(*,1035)
       WRITE(*,1120)
C
       CALL MAP_UTIL_ANALY(J8,10,CONST,SLOPE,CORR,DT4,DDFTO)
C
       WRITE(*,1035)
       BS = (-400.0-CONST)/SLOPE
C
       CALL MAP_STEEL_WSTINE(DFPRO,WS,WS1,J8)
C
C Modification made February 1991 to allow for large carbon concentrations
C Based on Metal Science paper on thermodynamics of martensitic transformations
C in plain carbon steels
C
       XMS = X1
       IF(XMS .GT. 0.0594D+00)  XMS = 0.0594D+00
       MS = (-1086.9D+00 + 2941.8D+00*XMS - 9.6016D+05*XMS*XMS
     & + 2.5382D+07*XMS*XMS*XMS - 1.8488D+08*XMS*XMS*XMS*XMS
     & - CONST)/SLOPE
C      
       WRITE(*,1100) WS1,WS
       IF (WS .LT. BS) THEN
         BS = WS
         WRITE(*,1115)BS
       ELSE
         WRITE(*,1117)BS
       ENDIF
C
       WRITE(*,1105)MS
       WRITE(*,1040)
C
C
       WRITE(*,1040)
C
30    CONTINUE
C
C ******* End of loop '30' *******
C
C
      STOP
C
C Format statements grouped here ...
C
1005  FORMAT (1H ,F7.0,2F7.0,F6.0,D10.2,F8.0,
     &2F9.4,F7.0,F8.4,1H ,I2,2F8.4,1H ,I2,D11.2,D11.2)
1010  FORMAT(' CTEMP=',F8.0,' ALPHA-1=',D10.4)
1015  FORMAT (7F6.2,I5)
1020  FORMAT (17H  CARBON CONTENT=,F10.5,6H  T10=,F10.6,
     &6H  T20=,F10.6,10H   WGAMMA=,F7.0)
1025  FORMAT (6H    C=,F8.4,6H   SI=,F8.4,6H   MN=,F8.4,
     &6H   NI=,F8.4,6H   MO=,F8.4,6H   CR=,F8.4,6H    V=,F8.4)
1030  FORMAT('   FPRO  FPROA   GMAX  CTEMP',
     &11H  X NUCLEUS,6H  FSON,9H      XEQ,9H    XEQ50,
     &6H   FTO,9H      XTO,13H        X44  ,
     &8H XTO400 ,15H      SHEART   ,10H  DIFFT   )
1035  FORMAT (4H    )
1040  FORMAT('--------------------------------------------------',
     &'-------------------------------',
     &'----------------------------------------------')
1045  FORMAT (16H *******NUMBER  ,I5,11H  *********)
1050  FORMAT(19X,' Carbon wt.% ?')
1055  FORMAT(19X,' Silicon wt.% ?')
1060  FORMAT(19X,' Manganese wt.% ?')
1065  FORMAT(19X,' Nickel wt.% ?')
1070  FORMAT(19X,' Molybdenum wt.% ?')
1075  FORMAT(19X,' Chromium wt.% ?')
1080  FORMAT(19X,' Vanadium wt.% ?')
1085  FORMAT(////19X,' Identification Number ?')
1090  FORMAT(I5,3D12.2)
1100  FORMAT(' WIDMANSTATTEN START TEMPERATURES ',F7.0,' & ',F7.0)
1105  FORMAT('     MARTENSITE START TEMPERATURE=',F7.0,' C')
1110  FORMAT('   WIDMANSTATTEN FERRITE START TEMPERATURE=',F7.0,' C')
1115  FORMAT(' NUCLEATION LIMITED BAINITE START TEMP=',F7.0,' C')
1117  FORMAT(' GROWTH LIMITED BAINITE START TEMP=',F7.0,' C')
1120  FORMAT('    ***** FTO VERSUS TEMPERATURE ****   ')
      END
C 
C*********************************************************************
C Subroutines
C
      SUBROUTINE LOGO
      WRITE(*,432)
      WRITE(*,1)
      WRITE(*,2)
      WRITE(*,2)
      WRITE(*,6)
      WRITE(*,2)
      WRITE(*,2)
300   WRITE(*,2)
      WRITE(*,8)
      WRITE(*,2)
      WRITE(*,9)
      WRITE(*,10)
      WRITE(*,2)
      WRITE(*,2)
      WRITE(*,1)
      WRITE(*,433)
432   FORMAT(//////////)
1     FORMAT(
     &10X,' *************************************************',
     &'**********')
2     FORMAT(10X,' **',55X,'**')
6     FORMAT(10X,' **',14X,'  TTT DIAGRAMS FOR STEELS ',15X,'**')
8     FORMAT(10X,' **',8X,'                  by                  ',
     &9X,'**')
9     FORMAT(10X,' **',8X,'         H. K. D. H. Bhadeshia        ',
     &9X,'**')
10    FORMAT(10X,' **',8X,'        University of Cambridge       ',
     &9X,'**')
433   FORMAT(////)
      PAUSE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE BOUND(A,B,C)
      DOUBLE PRECISION A,B,C
2      WRITE(*,1)B,C
1     FORMAT(12X,' Input value out of bounds'/
     &14X,' The limits are ',D12.4,' to ', D12.4/)
      CALL MAP_UTIL_REED(A)
      IF(A .LT. B .OR. A .GT. C)GOTO 2
      RETURN
      END
C 
C*********************************************************************
C
C
C H. K. D. H. Bhadeshia, 1984
C Natural logarithm of the activity of iron in austenite
C
      DOUBLE PRECISION FUNCTION MAP_STEEL_AFEG(XEQ,AJ)
      IMPLICIT NONE
      DOUBLE PRECISION XEQ,AJ,DEQ,TEQ
C
      DEQ=DSQRT(1-2*(1+2*AJ)*XEQ+(1+8*AJ)*XEQ*XEQ)
      TEQ=5.0*DLOG((1-XEQ)/(1-2*XEQ))
      TEQ=TEQ+6.0*DLOG((1-2*AJ+(4*AJ-1)*XEQ-DEQ)/(2*AJ*(2*XEQ-1)))
      MAP_STEEL_AFEG=TEQ
C
      RETURN
      END
C
C 
C*********************************************************************
C
      SUBROUTINE MAP_UTIL_ANALY(J8,J9,CONST,SLOPE,CORR,X,Y)
      DOUBLE PRECISION X(100),Y(100),AX,AY,AX2,AY2,AXY
      DOUBLE PRECISION CONST,SLOPE,CORR
      INTEGER I1,J8,J9,I
      I1=J8
      J8=J8-J9
      AX=0.0D+00
      AY=0.0D+00
      AX2=0.0D+00
      AY2=0.0D+00
      AXY=0.0D+00
      DO 1 I=1,J8
      AX=AX+X(I)
      AY=AY+Y(I)
      AXY=AXY+X(I)*Y(I)
      AX2=AX2+X(I)*X(I)
      AY2=AY2+Y(I)*Y(I)
1     CONTINUE
      CONST=(AY*AX2-AX*AXY)/(J8*AX2-AX*AX)
      SLOPE=((J8*AXY-AX*AY)/(J8*AX2-AX*AX))
      CORR=(J8*AXY-AX*AY)/(DSQRT((J8*AX2-AX*AX)*
     &(J8*AY2-AY*AY)))
      J8=I1
      RETURN
      END
C 
C*********************************************************************
C
C To calculate the carbon concentration (mole fraction) at the
C  T-zero phase boundary at a specified temperature.
C
C H K D H Bhadeshia, University of Cambridge
C
      SUBROUTINE MAP_STEEL_AXTO(H,S,H1,S1,XTO,T,W,W1,F,AJ,AJ1,STORE,
     &JN,J,R)
C
      IMPLICIT NONE
      DOUBLE PRECISION H,S,H1,S1,XTO,T,W,W1,F,AJ,AJ1,R,STORE
      DOUBLE PRECISION MAP_STEEL_FTO1, MAP_STEEL_G91,DA,DFTO,G9
      INTEGER J,JN
C
C XTO is the carbon concentration at the T-zero boundary
C T is the absolute temperature
C STORE is the stored energy in Joules per mole
C H, S, H1, S1, W, W1, F, AJ, AJ1 are thermodynamic quantities
C  defined in subroutines OMEGA, ENERGY and main program
C
C Initialize J
C
      J=0
C
C Calculate the driving force for the transformation of
C  austenite to ferrite without any change in chemical composition,
C  allowing for Zener ordering
C
 10     DFTO=MAP_STEEL_FTO1(H,S,XTO,T,W,W1,H1,S1,F,AJ,AJ1,R)+STORE
C
C Solve for XTO using Newton's iterative method
C
         J=J+1
         DA=DABS(DFTO)
         IF (DA .LE. 10.0D+00) GOTO 100
C
C Obtain differential of FTO1 with respect to XTO
C
       G9=MAP_STEEL_G91(XTO,T,W,W1,H1,S1,F,H,S,AJ,AJ1,R)
C
C Modify original guess of XTO, assuming that convergence occurs
C  within nine iterations
C
         IF (J .GE. JN) GOTO 100
         XTO=XTO-DFTO/G9
         IF (XTO .LE. 1.0D-12) GOTO 50
         GOTO 10
 50      XTO=0.0000D+00
C
 100        RETURN
            END
C
C 
C*********************************************************************
C
C CG CG DOUBLE PRECISION FUNCTION GIVING LFG  LN(ACTIVITY) OF CARBON IN AUSTENITE
      DOUBLE PRECISION FUNCTION MAP_STEEL_CG(X,T,W,R)
      IMPLICIT NONE
      DOUBLE PRECISION AJ,DG,EG,T,R,W,X
      AJ=1.0-DEXP(-W/(R*T))
         IF(X .LE. 1.0D-10) THEN
           MAP_STEEL_CG=DLOG(1.0D-10)
         ELSE
           DG=DSQRT(1.0-2.0*(1.0+2.0*AJ)*X+(1.0+8.0*AJ)*X*X)
           EG=5.0*DLOG((1.0-2.0*X)/X)+6.0*W/(R*T)+
     &     (38575.0-13.48*T)/(R*T)
           MAP_STEEL_CG=EG+6.0D+00*DLOG((DG-1+3*X)/(DG+1-3*X))
         ENDIF
      RETURN
      END
C
C 
C*********************************************************************
C
C DAFEG DAFEG DIFFERENTIAL OF LN ACTIVITY OF IRON IN GAMMA
      DOUBLE PRECISION FUNCTION MAP_STEEL_DAFEG(XEQ,AJ)
      IMPLICIT NONE
      DOUBLE PRECISION ETEQ,ETEQ2,DEQ,XEQ,AJ
      DEQ=DSQRT(1-2*(1+2*AJ)*XEQ+(1+8*AJ)*XEQ*XEQ)
      ETEQ=5*((1/(XEQ-1))+2/(1-2*XEQ))
      ETEQ2=6*((4*AJ-1-(0.5/DEQ)*(-2-4*AJ+2*XEQ+16*XEQ*AJ))
     &/(1-2*AJ+(4*AJ-1)*XEQ-DEQ))+6*(4*AJ/(2*AJ*(2*XEQ-1)))
      MAP_STEEL_DAFEG=ETEQ+ETEQ2
      RETURN
      END
C
C 
C*********************************************************************
C
C DCG DCG
C FUNCTION GIVING DIFFERENTIAL OF LN(ACTIVITY) OF CARBON IN AUSTENITE, LFG
C DIFFERENTIAL IS WITH RESPECT TO X
      DOUBLE PRECISION FUNCTION MAP_STEEL_DCG(X,T,W,R)
      IMPLICIT NONE
      DOUBLE PRECISION AJ,DG,DDG,X,T,W,R
      AJ=1.0-DEXP(-W/(R*T))
      DG=DSQRT(1.0-2.0*(1.0+2.0*AJ)*X+(1.0+8.0*AJ)*X*X)
      DDG=(0.5/DG)*(-2.0-4.0*AJ+2.0*X+16.0*AJ*X)
      MAP_STEEL_DCG=-((10.0/(1.0-2.0*X))+(5.0/X))+6.0*((DDG+3.0)
     &/(DG-1.0+3.0*X)-(DDG-3.0)/(DG+1.0-3.0*X))
      RETURN
      END
C
C 
C*********************************************************************
C
      DOUBLE PRECISION FUNCTION MAP_STEEL_ENERGY(T,T10,T20)
      IMPLICIT NONE
      DOUBLE PRECISION T,T10,T20,F,T7,T8
      T7=T-100.0D+0*T20
      T8=T7-1140.0D+0
      IF (T7 .LT. 300) F=1.38*T7-1499.0
      IF (T7.LT.700.AND.T7.GE.300)  F=1.65786*T7-1581.0
      IF (T7.LT.940.AND.T7.GE.700)  F=1.30089*T7-1331.0
      IF (T7.LT.940) GOTO 10
      F=T8*(-3.58434D-9*T8 + 2.70013D-6) - 1.04923D-3
      F=T8*(F*T8 + 0.26557D+0) - 8.88909D+0
 10   MAP_STEEL_ENERGY=(141.0*T10 + F)*4.187
      RETURN
      END
C
C 
C*********************************************************************
C Function MAP_STEEL_FTO1
C
C Produced by :-
C
C H. K. D. H. Bhadeshia
C
C Department of Materials Science and Metallurgy,
C Pembroke Street, Cambridge CB2 3QZ, U. K.
C 31 March 1987
C
C Calculates the free energy change accompanying the transformation
C from austenite to ferrite of the same chemical composition, including
C a Zener ordering term. The latter describes the ordering of carbon
C atoms, that leads the body-centered cubic lattice of ferrite becoming
C body-centered tetragonal. The degree of ordering increases as the
C carbon concentration increases, or as the transformation temperature
C decreases.
C
C References:
C
C  1. C. Zener Trans. AIME 167 (1946) 550.
C
C  2. J. C. Fisher, Metals Transactions 185 (1949) 688-690.
C
C  3. H. K. D. H. Bhadeshia and D. V. Edmonds
C      Acta Metallurgica 28 (1980) 1265-1273.
C      Also see laboratory book 7.
C
C----------------------------------------------------------------------
C
C
       DOUBLE PRECISION FUNCTION MAP_STEEL_FTO1(H,S,X,T,W,W1,
     & H1,S1,F,AJ,AJ1,R)
C
C  modified July 2002, to correct calculation for the range T60 .gt. 0.25
C  courtesy Chikaro Nakao
C
       IMPLICIT NONE
C
C Input arguments.
C
       DOUBLE PRECISION AJ, AJ1, F, H, H1, R, S, S1, T, W, W1, X
 	 double precision first, second, third
C
C Local variables.
C
       DOUBLE PRECISION D, D11, T60, ZENER, ZEN1, ZEN2
C
C Begin function :-
C
       D  = SQRT(1-2*(1+2*AJ)*X+(1+8*AJ)*X*X)
       D11= SQRT(9-6*X*(2*AJ1+3)+(9+16*AJ1)*X*X)
C
C Calculate T60, which is the value of the actual temperature T
C   divided by the critical temperature beyond which there is no
C   Zener ordering. X is the mole fraction of carbon in the ferrite.
C If T60>1, the transformation occurs above the ordering temperature
C   and Zener ordering does not occur.
C
       T60 = T*(1-X)/(28080*X)
C
       IF (T60 .GT. 1.0) THEN
          GOTO 30
       END  IF
C
C Calculate the contribution to the free energy change due to
C  Zener ordering.
C
       IF (T60 .LT. 0.25) THEN
          GOTO 10
       END  IF
C
C Polynomial fit to data in Table 2 of Fischer (1949)
C
       ZEN1=0.2307+42.7974*T60-233.8631*(T60**2)+645.4485*(T60**3)
     & -954.3995*(T60**4)+711.8095*(T60**5)-211.5136*(T60**6)
       ZEN2=-2.6702+45.6337*T60-225.3965*(T60**2)+567.7112*(T60**3)
     & -771.6466*(T60**4)+538.1778*(T60**5)-151.3818*(T60**6)
       GOTO 20
C
10     CONTINUE
       ZEN2 = 1
       ZEN1 = 3.295
C
20     CONTINUE
       ZENER=(((ZEN2*X)**2)*(-50898.56)/(1-X))+ZEN1*T*X*0.6623741
C
C Convert from calories per mole to Joules per mole
C
       ZENER=ZENER*4.187
       GOTO 40
C
30     CONTINUE
       ZENER=0.0
C
C Calculation of the Zener ordering term complete.  Calculate the free
C  energy change accompanying the change from austenite to ferrite of the
C  same composition, including Zener ordering term. See Bhadeshia
C  and Edmonds [3].
C
40     CONTINUE

       first  = D+1-3*X
	 second = 2*AJ*(2*X-1)
	 third  = D11+3-5*X

       MAP_STEEL_FTO1 = X*R*T*DLOG(X*X)+
     &                  X*(H1-(H)-(S1-(S))*T+4*W1-6*W)-
     &                  R*T*(1-X)*DLOG((1-X)**4)+
     &                  5*R*T*(1-2*X)*DLOG(1-2*X)-
     &                  R*T*X*DLOG(((D-1+3*X)/(D+1-3*X))**6)-
     &                  R*T*(1-X)*DLOG((
     &					  (1-2*AJ+(4*AJ-1)*X-D)/
     &					  (2*AJ*(2*X-1))
     &                    )**6
     &                  )+
     &                  3*R*T*X*DLOG(3-4*X)+
     &                  R*T*X*DLOG(((D11-3+5*X)/(D11+3-5*X))**4)+
     &                  (1-X)*F+
     &                  ZENER
C
C
       RETURN
       END
C
C
C 
C*********************************************************************
C
      SUBROUTINE MAP_STEEL_GMAAX(A1,A,W1,F,R,T,X,AFE,H1,S1)
      IMPLICIT NONE             
      DOUBLE PRECISION A1,A,W1,F,R,T,X,AFE,H1,S1
      DOUBLE PRECISION AJ1,D1,B1,B2,B3,A1FE,TEST,DA1,DA2
      DOUBLE PRECISION ERROR,DA1FE
C AVER=1.2
C CALCULATION OF THE OPTIMUM NUCLEUS C CONTENT AND ACTIVITY OF C IN
C FERRITE NUCLEUS
C
C Estimate a value for X, the optimum carbon concentration of
C  the ferrite nucleus, in mole fraction
C February 1991
       X=6.3998D-07*T-3.027D-04
       IF(X .LE. 0.0D+00)  X=1.0D-13
       IF(X .GT. 0.32D-03) X=0.32D-03
C Estimation complete
C
      AJ1=1.0D+00-DEXP(-W1/(R*T))
1     D1=DSQRT(9.0D+00-6.0D+00*X*(2.0D+00*AJ1+3.0D+00)
     &+(9.0D+00+16.0D+00*AJ1)*X*X)
      B1=((D1-3.0D+00+5.0D+00*X)/(D1+3.0D+00-5.0D+00*X))
      B2=((3.0D+00-4.0D+00*X)/X)
      B3=(H1 - S1*T + 4.0D+00*W1)/(R*T)

      A1=DLOG(B1*B1*B1*B1*B2*B2*B2)+B3
C
      IF(X .GT. 1.0D-08)THEN
        A1FE=DLOG(1.0D+00-X)
      ELSE
        A1FE=X
      ENDIF
C
      TEST=F+R*T*(A1FE-AFE) - R*T*(A1-A)
C
C Newton iteration
C
      IF (DABS(TEST) .GT. 10.0) THEN
        DA1=(3.0D+00*X/(3.0D+00-4.0D+00*X))*(
     &  (4.0D+00*X-3.0D+00)/(X*X)-4.0D+00/X)
        DA2=(0.5D+00/D1)*(-12.0D+00*AJ1-18.0D+00+
     &  18.0D+00*X+32.0D+00*AJ1*X)
        DA2=4.0D+00*(((DA2+5.0D+00)/(D1-3.0D+00+5.0D+00*X))
     &  -((DA2-5.0D+00)/(D1+3.0D+00-5.0D+00*X)))
        DA1=DA1+DA2
        DA1FE=1.0D+00/(X-1.0D+00)
        ERROR=TEST/(R*T*(DA1FE-DA1))
        IF (ERROR .GT. X) ERROR = 0.3D+00*X
        X=DABS(X-ERROR)
        GOTO 1
      ENDIF
C End of iteration
      RETURN
      END
C
C 
C*********************************************************************
C
      SUBROUTINE MAP_STEEL_OMEGA(C,W,XBAR,T10,T20,J)
C SUBROUTINE TO CALCULATE THE CARBON CARBON INTERACTION ENERGY IN
C AUSTENITE, AS A FUNCTION OF ALLOY COMPOSITION.  BASED ON .MUCG18
C THE ANSWER IS IN JOULES PER MOL.   **7 OCTOBER 1981**
      IMPLICIT NONE
      DOUBLE PRECISION C(8),W,P(8),B1,B2,Y(8),T10,T20,B3,XBAR
      INTEGER IU,J
      B3=0.0D+00
      IF(J .EQ. 1) GOTO 2
      C(8)=C(1)+C(2)+C(3)+C(4)+C(5)+C(6)+C(7)
      C(8)=100.0D+00-C(8)
      C(8)=C(8)/55.84D+00
      C(1)=C(1)/12.0115D+00
      C(2)=C(2)/28.09D+00
      C(3)=C(3)/54.94D+00
      C(4)=C(4)/58.71D+00
      C(5)=C(5)/95.94D+00
      C(6)=C(6)/52.0D+00
      C(7)=C(7)/50.94D+00
2     B1=C(1)+C(2)+C(3)+C(4)+C(5)+C(6)+C(7)+C(8)
      DO 107 IU=2,7
      Y(IU)=C(IU)/C(8)
107   CONTINUE
      DO 106 IU=1,8
      C(IU)=C(IU)/B1
106   CONTINUE
      XBAR=C(1)
      XBAR=DINT(10000.0D+00*XBAR)
      XBAR=XBAR/10000
      B2=0.0D+00
      T10=Y(2)*(-3)+Y(3)*2+Y(4)*12+Y(5)*(-9)+Y(6)*(-1)+Y(7)*(-12)
      T20=-3*Y(2)-37.5*Y(3)-6*Y(4)-26*Y(5)-19*Y(6)-44*Y(7)
C
C     Polynomials representing carbon-carbon interaction energy (J/mol)
C     in austenite as a function of the molecular fraction of individual solutes.
C
      P(2)=-2.4233D+07+6.9547D+07*C(2)
      P(2)=+3.864D+06+P(2)*C(2)
      P(2)=+45802.87+(-280061.63+P(2)*C(2))*C(2) 
      P(2)=2013.0341+(763.8167+P(2)*C(2))*C(2)
      P(3)=2.0119D+06+(3.1716D+07-1.3885D+08*C(3))*C(3)
      P(3)=+6287.52+(-21647.96+P(3)*C(3))*C(3)
      P(3)=2012.067+(-1764.095+P(3)*C(3))*C(3)
      P(4)=-2.4968D+07+(1.8838D+08-5.5531D+08*C(4))*C(4)
      P(4)=-54915.32+(1.6216D+06+P(4)*C(4))*C(4)
      P(4)=2006.8017+(2330.2424+P(4)*C(4))*C(4)
      P(5)=-1.3306D+07+(8.411D+07-2.0826D+08*C(5))*C(5)
      P(5)=-37906.61+(1.0328D+06+P(5)*C(5))*C(5)
      P(5)=2006.834+(-2997.314+P(5)*C(5))*C(5)
      P(6)=+8.5676D+06+(-6.7482D+07+2.0837D+08*C(6))*C(6)
      P(6)=+33657.8+(-566827.83+P(6)*C(6))*C(6)
      P(6)=2012.367+(-9224.2655+P(6)*C(6))*C(6)
      P(7)=+5411.7566
     &+(250118.1085-4.1676D+06*C(7))*C(7)
      P(7)=2011.9996+(-6247.9118+P(7)*C(7))*C(7)
      DO 108 IU=2,7
      B3=B3+P(IU)*Y(IU)
      B2=B2+Y(IU)
108   CONTINUE
      IF (B2 .EQ. 0.0D+00) GOTO 455
      W=(B3/B2)*4.187
      GOTO 456
455   W=8054.0
456   CONTINUE
      RETURN
      END
C 
C*********************************************************************
C MAP_UTIL_REED
C To read a real number in a way which to some extent traps typing errors
C
      SUBROUTINE MAP_UTIL_REED(A)
      IMPLICIT NONE
      DOUBLE PRECISION A
C
996   READ(*,*,ERR=999)A
          GOTO 998
999       WRITE(*,997)
997       FORMAT(19X,' Incorrect Input. Try again'/)
          GOTO 996
C
998     RETURN
        END
C
C 
C*********************************************************************
C MAP_UTIL_REEDI
C To read integers in a way which to some extent traps typing errors
C
      SUBROUTINE MAP_UTIL_REEDI(I)
      IMPLICIT NONE
      INTEGER I
C
996   READ(*,*,ERR=999)I
          GOTO 998
999       WRITE(*,997)
997       FORMAT(19X,' Incorrect Input. Try again'/)
          GOTO 996
C
998     RETURN
        END
C
C 
C*********************************************************************
C
      SUBROUTINE MAP_STEEL_TTTT(T,GMAX,SHEART,DIFFT,R)
      IMPLICIT NONE
      DOUBLE PRECISION T,GMAX,SHEART,DIFFT,R
      SHEART=DEXP((0.2432D+06/(R*T))-0.135D+03+20.0*DLOG(T)
     &-5*DLOG(DABS(GMAX)))
      DIFFT=DEXP((0.6031D+06/(R*T))-0.1905D+03+20.0*DLOG(T)
     &-4.0D+00*DLOG(DABS(GMAX)))
      RETURN
      END
C 
C*********************************************************************
C Function MAP_STEEL_WSFUN
C
      DOUBLE PRECISION FUNCTION MAP_STEEL_WSFUN(KTEMP,T0)
      IMPLICIT NONE
      DOUBLE PRECISION KTEMP,T0
C Version 1.1 May 1991
C
C Gn curve for Widmanstatten ferrite nucleation, Acta Metall. 1981
C J/mol
C based on FPRO rather than GMAAX
C
      MAP_STEEL_WSFUN=3.251745029D+00*(KTEMP-T0)-2183.014D+0
C
C When equal to or greater than zero, no problem with nucleation

      RETURN
      END
C 
C*********************************************************************
C Subroutine MAP_STEEL_WSTINE
C
      SUBROUTINE MAP_STEEL_WSTINE(DFPRO,WS,WS1,J8)
C Version 1.1 May 1991
C August 1995
      IMPLICIT NONE
      DOUBLE PRECISION DFPRO(40),WS,WS1,KTEMP,V14
      DOUBLE PRECISION MAP_STEEL_WSFUN,T0
      INTEGER J8,J,I
	PARAMETER(T0=273.15D+00)
      J=0
      DO 10 I=1,J8
      KTEMP=200.00D+00+T0+(I-1)*20.0D+00
      V14=MAP_STEEL_WSFUN(KTEMP,T0)
C
C Stored energy for growth of Wid ferrite = 50 J/mol
      IF(DFPRO(I) .GT. -50.0D+00) GOTO 10
C
C WS1 is the lower intersection of Gn and Fpro curves
        IF(DFPRO(I) .LE. V14 .AND. J .EQ. 0) THEN
           WS1=KTEMP-T0
        ENDIF
      IF(DFPRO(I) .GE. V14)J=1
C
C WS is the upper intersection of Gn and Fpro curves
      IF(DFPRO(I) .LE. V14) WS=KTEMP-T0
 10   CONTINUE
      RETURN
      END
C 
C*********************************************************************
C
C Function MAP_STEEL_G91
C
C Produced by :-
C
C H.K.D.Bhadeshia,
C Phase Transformations Group,
C Department of Materials Science and Metallurgy,
C University of Cambridge,
C Cambridge, UK.
C
C Purpose :-
C
C To calculate the differential of MAP_STEEL_FTO1 with respect to XTO
C  (see subroutine MAP_STEEL_FTO1 for description of parameters).  The 
C  differentiation is used in order to apply the Newton Iteration.
C
C Unpublished work, H. K. D. H. Bhadeshia, University of Cambridge
C  See laboratory book 5B
C
C Input parameters :-
C
C XTO is the carbon concentration at the T0 boundary.
C T is the temperature (in kelvin).
C W is the carbon-carbon interaction energy in austenite 
C  (in joules per mole).
C W1 is the carbon-carbon interaction energy in ferrite 
C  (in joules per mole).
C H1 is the excess partial molar enthalpy of solution of carbon
C  in ferrite (in joules per mole).
C S1 is the excess partial molar entropy of solution of carbon
C  in ferrite (in joules per mole per kelvin).
C F is the energy.
C H is the excess partial molar enthalpy of solution of carbon
C  in austenite (in joules per mole).
C S is the excess partial molar entropy of solution of carbon
C  in austenite (in joules per mole).
C AJ  = 1 - e(W/RT), where R is the universal gas constant.
C AJ1 = 1 - e(W1/RT), where R is the universal gas constant.
C R is the universal gas constant (in joules per mole per kelvin)
C
C----------------------------------------------------------------------
C
       DOUBLE PRECISION FUNCTION MAP_STEEL_G91(XTO,T,W,W1,H1,S1,F,
     &                               H,S,AJ,AJ1,R)
C
C Input arguments.
C
       DOUBLE PRECISION AJ, AJ1, F, H, H1, R, S, S1, T, W, W1, XTO
C
C Local variables.
C
       DOUBLE PRECISION DT5, DT6, FD, FD1, G1
       DOUBLE PRECISION DZEN1 ,DZEN2, DZEN3, DZEN6, DZEN7, DZEN8
       DOUBLE PRECISION V1, V2, V3, V4, V5, V6, V7, V8, V9
C
C Body of function :-
C
       FD = SQRT(1-2*(1+2*AJ)*XTO+(1+8*AJ)*XTO*XTO)
       FD1= SQRT(9-6*XTO*(2*AJ1+3)+(9+16*AJ1)*XTO*XTO)
C
       DT5 = 28080*XTO/(1-XTO)
       DT6 = T/DT5
C
       IF (DT6 .GT. 1.0) THEN
          GOTO 30
       END  IF
C
       IF (DT6 .LT. 0.25) THEN
          GOTO 10
       END  IF
C
       DZEN1 = 0.2307 +42.7974 *DT6-233.8631 *(DT6**2) +645.4485
     &  *(DT6**3) -954.3995 *(DT6**4) +711.8095 *(DT6**5)
     &  -211.5136 *(DT6**6)
       DZEN2 = -2.6702 +45.6337 *DT6 -225.3965 *(DT6**2) +567.7112
     &  *(DT6**3) -771.6466 *(DT6**4) +538.1778 *(DT6**5)
     &  -151.3818 *(DT6**6)
C
       GOTO 20
C
10     DZEN2 = 1
       DZEN1 = 3.295
20     DZEN3 = (((DZEN2*XTO)**2)*(-50898.56)/(1-XTO))+DZEN1*T*XTO*
     &         (0.6623741)
C
       DZEN3 = DZEN3*4.187
       GOTO 40
30     DZEN3 = 0.0
C
40     V1 = FD-1+3*XTO
       V2 = FD+1-3*XTO
       V3 = 1-2*AJ+(4*AJ-1)*XTO-FD
       V4 = 2*AJ*(2*XTO-1)
       V5 = FD1-3+5*XTO
       V6 = FD1+3-5*XTO
       V7 = (XTO-1-2*AJ+8*XTO*AJ)/FD
       V8 = (9*XTO-9-6*AJ1+16*AJ1*XTO)/FD1
       V9 = H1-(H)-(S1-(S))*T-6*W+4*W1
C
       G1 = 2 +DLOG(XTO**2) +4 +DLOG((1-XTO)**4) -10-DLOG((1-2*XTO)**10)
     &  -LOG((V1/V2)**6) -6 *((XTO/V1)*(V7+3+V1*(3-V7)/V2))
     &  +LOG((V3/V4)**6) -6 *((1-XTO)/V3)*(4*AJ*(1-(V3/V4))-V7)
     &  +3 *(LOG(3-4*XTO) -4*XTO/(3-4*XTO)) +DLOG((V5/V6)**4)
     &  +4*(XTO/V5) *(V8+5+(V5/V6)*(5-V8))
C
       IF (DT6 .GT. 1.0) THEN
          GOTO 50
       END  IF
C
       DZEN6 = (-3.3948 +13.6112 *DT6 -13.4376 *(DT6**2))
     &         *T/(28080*((1-XTO)**2))
       DZEN7 = (-3.3118 +15.7462 *DT6 -23.2449 *(DT6**2))
     &         *T/(28080*((1-XTO)**2))
       DZEN8 = 50898 *((DZEN2*XTO)**2)/((1-XTO)**2)
     &         +(-50898* (2* DZEN2 *DZEN6 *(XTO**2) +2 *XTO
     &         *(DZEN2**2))/(1-XTO)) +DZEN1 *T *0.6623741 +DZEN7
     &         *T *XTO *0.6623741
C
       GOTO 60
C
50     DZEN8 = 0.0
C
60     MAP_STEEL_G91 = V9 +R *T *G1 +DZEN8 -F
C
       RETURN
       END
